=== debian/changelog ===
bctoolbox (4.4.13-4) unstable; urgency=medium

  * Cherry-pick upstream patch e142436 (Closes: #1012900)
  * Work around a build-breaking inlining issue

 -- Dennis Filder <d.filder@web.de>  Sun, 14 Aug 2022 10:44:26 +0000

bctoolbox (4.4.13-3) unstable; urgency=medium

  [ Bernhard Schmidt ]
  * Drop cmake version constraint satisfied in oldstable

  [ Andrea Pappacoda ]
  * d/patches: fix GCC 11 build. Closes: #983985

 -- Bernhard Schmidt <berni@debian.org>  Sun, 30 Jan 2022 14:13:51 +0100

bctoolbox (4.4.13-2) unstable; urgency=medium

  * Team upload
  * Release to unstable
  * Drop Daniel as Uploader, add myself
  * Fix Homepage, bump S-V to 4.5.1 (Closes: #974749)

 -- Bernhard Schmidt <berni@debian.org>  Fri, 25 Dec 2020 14:28:41 +0100

bctoolbox (4.4.13-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.4.13
  * Change Vcs-* to linphone-stack subgroup
  * Use debhelper-compat (= 12)

 -- Bernhard Schmidt <berni@debian.org>  Mon, 07 Dec 2020 10:21:34 +0100

bctoolbox (4.4.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.4.0
    - update d/copyright, upstream has relicensed to GPL-3+

 -- Bernhard Schmidt <berni@debian.org>  Wed, 08 Jul 2020 17:04:52 +0200

bctoolbox (4.3.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.3.1
  * Packaging Change: Switch from upstream git repository to upstream
    release tarballs. All of the other part projects use this scheme,
    make it consistent in the linphone stack.
  * d/watch: Switch to upstream primary Gitlab, only use releases
  * d/gbp.conf: Drop pristine-tar and use default upstream tags
  * Adjust d/libbctoolbox1.shlibs for new upstream version
  * Delete all patches, applied/fixed upstream
  * Fix Homepage

 -- Bernhard Schmidt <berni@debian.org>  Mon, 01 Jun 2020 22:58:16 +0200
