## bctoolbox 5.0.37

=== debian/changelog ===
bctoolbox (5.0.37-3) unstable; urgency=medium

  * Team upload.
  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Sun, 11 Sep 2022 16:15:14 +0200

bctoolbox (5.0.37-2) experimental; urgency=medium

  * Cherry-pick upstream patch e142436 (Closes: #1012900)
  * Work around a build-breaking inlining issue

 -- Dennis Filder <d.filder@web.de>  Sun, 24 Jul 2022 08:32:53 +0000

bctoolbox (5.0.37-1) experimental; urgency=medium

  * Team upload
  * New upstream version 5.0.37

  [Dennis Filder]
  * libdecaf support.
  * Adjust to GCC 11 (Closes: #983985)
  * Declare libbctoolbox-dev Multi-Arch: same
  * Support for DTLS SRTP protection profiles as provided by mbedTLS 2.28

 -- Dennis Filder <d.filder@web.de>  Fri, 28 Jan 2022 19:51:47 +0100
