## bctoolbox 5.1.64

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # CMakeLists.txt
-# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
+# Copyright (C) 2010-2021  Belledonne Communications, Grenoble France
 #
 ############################################################################
 #
@@ -21,9 +21,14 @@
 ############################################################################
 
 cmake_minimum_required(VERSION 3.2)
-set(CMAKE_MACOSX_RPATH ON) # Before cmake 3.0.0, MACOSX_RPATH was not set to ON by default - however this is no good reason to not enable it by default
-
-project(bctoolbox VERSION 4.4.0)
+
+# CMP0077 policy is required by Flexisip build. Remove it once the CMake required
+# version is higer or equal to 3.13.
+if(NOT CMAKE_VERSION VERSION_LESS 3.13)
+	cmake_policy(SET CMP0077 NEW)
+endif()
+
+project(bctoolbox VERSION 5.1.0)
 
 set(BCTOOLBOX_VERSION "${PROJECT_VERSION}")
 set(BCTOOLBOX_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
@@ -43,6 +48,10 @@
 option(ENABLE_TESTS "Enable compilation of tests" ON)
 option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making (CMake >= 3.11)" OFF)
 
+# Hidden non-cache options:
+# * DISABLE_BC_PACKAGE_SEARCH: skip find_package() for every BC package (bctoolbox, ortp, etc.)
+
+
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_EXTENSIONS NO)
 
@@ -91,7 +100,7 @@
 	endif()
 endif()
 
-if(HAVE_SSL_GET_DTLS_SRTP_PROTECTION_PROFILE)
+if(DTLS_SRTP_AVAILABLE)
 	message(STATUS "DTLS SRTP available")
 	set(HAVE_DTLS_SRTP 1)
 else()
@@ -108,17 +117,23 @@
 	set(LIBS_PRIVATE "${LIBS_PRIVATE} -L${polarssl_library_path} -lpolarssl")
 endif()
 
-if(ENABLE_TESTS_COMPONENT)
-  find_package(BcUnit CONFIG REQUIRED)
-  cmake_push_check_state(RESET)
-	list(APPEND CMAKE_REQUIRED_INCLUDES ${BCUNIT_INCLUDE_DIRS})
-	list(APPEND CMAKE_REQUIRED_LIBRARIES ${BCUNIT_LIBRARIES})
-	check_symbol_exists("CU_get_suite" "BCUnit/BCUnit.h" HAVE_CU_GET_SUITE)
-	check_symbol_exists("CU_curses_run_tests" "BCUnit/BCUnit.h" HAVE_CU_CURSES)
-	check_symbol_exists("CU_set_trace_handler" "BCUnit/Util.h" HAVE_CU_SET_TRACE_HANDLER)
-	cmake_pop_check_state()
-	set(TESTER_REQUIRES_PRIVATE "bcunit")
-endif()
+if (ENABLE_TESTS_COMPONENT)
+	if (NOT DISABLE_BC_PACKAGE_SEARCH)
+		find_package(BcUnit CONFIG REQUIRED)
+		cmake_push_check_state(RESET)
+		list(APPEND CMAKE_REQUIRED_INCLUDES ${BCUNIT_INCLUDE_DIRS})
+		list(APPEND CMAKE_REQUIRED_LIBRARIES ${BCUNIT_LIBRARIES})
+		check_symbol_exists("CU_get_suite" "BCUnit/BCUnit.h" HAVE_CU_GET_SUITE)
+		check_symbol_exists("CU_curses_run_tests" "BCUnit/BCUnit.h" HAVE_CU_CURSES)
+		check_symbol_exists("CU_set_trace_handler" "BCUnit/Util.h" HAVE_CU_SET_TRACE_HANDLER)
+		cmake_pop_check_state()
+		set(TESTER_REQUIRES_PRIVATE "bcunit")
+	else ()
+		set(HAVE_CU_GET_SUITE ON)
+		set(HAVE_CU_SET_TRACE_HANDLER ON)
+		set(TESTER_REQUIRES_PRIVATE "bcunit")
+	endif ()
+endif ()
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/bctoolbox.pc.in ${CMAKE_CURRENT_BINARY_DIR}/bctoolbox.pc)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/bctoolbox.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
