=== include/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	compiler.h
 	defs.h
 	exception.hh
+	utils.hh
 	list.h
 	logging.h
 	map.h
@@ -33,6 +34,9 @@
 	regex.h
 	vconnect.h
 	vfs.h
+	vfs_standard.h
+	vfs_encrypted.hh
+	param_string.h
 )
 
 if(APPLE)
@@ -41,6 +45,7 @@
 
 if(MBEDTLS_FOUND OR POLARSSL_FOUND)
 	list(APPEND HEADER_FILES crypto.h)
+	list(APPEND HEADER_FILES crypto.hh)
 endif()
 
 if(ENABLE_TESTS_COMPONENT)
