=== debian/changelog ===
bctoolbox (5.1.64-2) unstable; urgency=medium

  * Upload to unstable

 -- Bernhard Schmidt <berni@debian.org>  Sun, 27 Nov 2022 17:22:50 +0100

bctoolbox (5.1.64-1) experimental; urgency=medium

  * New upstream version 5.1.64

 -- Dennis Filder <d.filder@web.de>  Wed, 12 Oct 2022 19:23:53 +0200
