=== debian/control ===
--- 
+++ 
@@ -7,11 +7,12 @@
                debhelper-compat (= 13),
                libdecaf-dev,
                libmbedtls-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://gitlab.linphone.org/BC/public/bctoolbox
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/bctoolbox.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/bctoolbox
+Description: Helper code for software by Belledonne Communications
 
 # libbctoolbox-dev must be the first package for
 # upstream-version-from-changelog to get installed into it
